=== debian/changelog ===
calico (3.26.0-0parrot1) lory; urgency=medium

  * Rebuild for Parrot 6.0.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Thu, 07 Sep 2023 00:32:53 +0200

calico (3.26.0-0kali1) kali-dev; urgency=medium

  * New upstream version 3.26.0
  * Refresh patches

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 31 May 2023 17:29:18 +0200

calico (3.25.1-0kali1) kali-dev; urgency=medium

  * Update debian/watch
  * New upstream version 3.25.1
  * Refresh patches

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 28 Apr 2023 15:06:37 +0200

calico (3.25.0-0kali2) kali-dev; urgency=medium

  * Add missing build-dep ca-certifcates

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 14 Mar 2023 10:49:53 +0100

calico (3.25.0-0kali1) kali-dev; urgency=medium

  * Initial release.

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 27 Jan 2023 16:59:59 +0100
