=== debian/control ===
Source: calico
Section: misc
Priority: optional
Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 ca-certificates,
 golang
Standards-Version: 4.6.2
Homepage: https://github.com/projectcalico/calico

Package: calicoctl
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description:  networking and network security solution for Kubernetes
 This package contains the command line tool for calico. Calico is a widely
 adopted, battle-tested open source networking and network security solution
 for Kubernetes, virtual machines, and bare-metal workloads.
