## calico 3.30.2+ds

=== debian/changelog ===
calico (3.30.2+ds-0kali2) kali-dev; urgency=medium

  * Add a patch to fix the build on 32 bits arch

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 27 Jun 2025 15:11:23 +0200

calico (3.30.2+ds-0kali1) kali-dev; urgency=medium

  * New upstream version 3.30.2+ds
  * Update build for new upstream release

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 26 Jun 2025 15:05:13 +0200

calico (3.30.1+ds-0kali1) kali-dev; urgency=medium

  * New upstream version 3.30.1+ds

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 04 Jun 2025 15:46:28 +0200

calico (3.30.0+ds-0kali1) kali-dev; urgency=medium

  * New upstream version 3.30.0+ds
  * Update debian/copyright
  * Refresh patches

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 09 May 2025 15:45:18 +0200

calico (3.29.3+ds-0kali1) kali-dev; urgency=medium

  * New upstream version 3.29.3+ds

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 26 Mar 2025 09:57:27 +0100

calico (3.29.1+ds-0kali1) kali-dev; urgency=medium

  * New upstream version 3.29.1+ds

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 21 Nov 2024 16:14:41 +0100

calico (3.29.0+ds-0kali1) kali-dev; urgency=medium

  * New upstream version 3.29.0+ds

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 30 Oct 2024 15:05:04 +0100

calico (3.28.2+ds-0kali1) kali-dev; urgency=medium

  * New upstream version 3.28.2+ds

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 24 Sep 2024 17:18:17 +0200

calico (3.28.1+ds-0kali1) kali-dev; urgency=medium

  * New upstream version 3.28.1+ds

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 20 Aug 2024 11:19:54 +0200

calico (3.28.0+ds-0kali1) kali-dev; urgency=medium

  * New upstream version 3.28.0+ds
  * Refresh patches

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 21 May 2024 16:38:43 +0200

calico (3.27.3+ds-0kali1) kali-dev; urgency=medium

  * New upstream version 3.27.3+ds

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 02 Apr 2024 15:55:33 +0200

calico (3.27.2+ds-0kali1) kali-dev; urgency=medium

  * New upstream version 3.27.2+ds

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 19 Feb 2024 13:54:45 +0100

calico (3.27.0+ds-0kali1) kali-dev; urgency=medium

  * New upstream version 3.27.0+ds
  * Refresh patches

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 08 Jan 2024 15:56:54 +0100

calico (3.26.4+ds-0kali1) kali-dev; urgency=medium

  * New upstream version 3.26.4+ds

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 17 Nov 2023 17:33:11 +0100

calico (3.26.2+ds-0kali1) kali-dev; urgency=medium

  * New upstream version 3.26.2+ds
  * Refresh patches

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 05 Oct 2023 11:41:56 +0200

calico (3.26.1+ds-0kali1) kali-dev; urgency=medium

  * Filter .gitattributes
  * New upstream version 3.26.1+ds

 -- Steev Klimaszewski <steev@kali.org>  Fri, 29 Sep 2023 20:26:31 -0500

calico (3.26.1-0kali1) kali-dev; urgency=medium

  * New upstream version 3.26.1
  * Remove lintian-overrides

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 07 Sep 2023 16:10:00 +0200
