=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: calico
 Section: misc
 Priority: optional
-Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
-Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
+Maintainer: Kali Developers <devel@kali.org>
+Uploaders: Sophie Brun <sophie@offensive-security.com>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
@@ -10,6 +10,8 @@
  golang
 Standards-Version: 4.6.2
 Homepage: https://github.com/projectcalico/calico
+Vcs-Browser: https://gitlab.com/kalilinux/packages/calico
+Vcs-Git: https://gitlab.com/kalilinux/packages/calico.git
 
 Package: calicoctl
 Architecture: any
