=== debian/changelog ===
calico (3.30.3+ds-0kali1) kali-dev; urgency=medium

  * Update my email
  * New upstream version 3.30.3+ds
  * Refresh patches
  * Update debian/vendor

 -- Sophie Brun <sophie@kali.org>  Mon, 25 Aug 2025 10:42:27 +0200
