=== debian/rules ===
--- 
+++ 
@@ -5,6 +5,7 @@
 
 export GOCACHE=$(CURDIR)/vendor
 export GOPATH=$(CURDIR)/vendor
+export GOPROXY=off
 
 %:
 	dh $@
